; Script generated by the HM NIS Edit Script Wizard.

; Script "Modes"
!define PYTHONLESSMODE   ; Packs required python files along with installer,
                          ; so user don't need to download pyhton
;!define MINGWBUILD       ; Include Mingw dependency dlls
!define MSVC8BUILD      ; Include Microsoft VC++ 8.0 ( 2005 ) dependency dlls

; HM NIS Edit Wizard helper defines
!define VERSION "12.9.17"
!define PRODUCT_NAME "Wolfpack"
!define PRODUCT_VERSION "${VERSION}"
!define PRODUCT_PUBLISHER "Wolfpack Project"
!define PRODUCT_WEB_SITE "http://www.wpdev.org/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\wolfpack.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

SetCompressor /solid lzma

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE "..\..\release\LICENSE.GPL"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "Wolfpack"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\wolfpack.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
;Languages
!insertmacro MUI_LANGUAGE "English" # first language is the default language

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

VIProductVersion "${VERSION}.0"
VIAddVersionKey /LANG=${LANG_ENGLISH} "ProductName" "${PRODUCT_NAME}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "Comments" "A test comment"
VIAddVersionKey /LANG=${LANG_ENGLISH} "CompanyName" "${PRODUCT_PUBLISHER}"
;VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalTrademarks" "Test Application is a trademark of Fake company"
VIAddVersionKey /LANG=${LANG_ENGLISH} "LegalCopyright" " ${PRODUCT_PUBLISHER}"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileDescription" "${PRODUCT_NAME} Ultima Online game server"
VIAddVersionKey /LANG=${LANG_ENGLISH} "FileVersion" "${VERSION}.0"

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "setup-wolfpack-${VERSION}.exe"
InstallDir "c:\wolfpack"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

!execute "$%QTDIR%\bin\lrelease ..\wolfpack.pro"

Section "Core" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite on

  File "..\..\release\wolfpack.exe"
  File "..\..\release\AUTHORS"
  File "..\..\release\Changelog"
  File "..\..\release\COPYING"
  File "..\..\release\COPYRIGHT"
  File "..\..\release\INSTALL"
  File "..\..\release\LICENSE.GPL"
  File "..\..\release\NEWS"
  File "..\..\release\README"
  File "..\*.sql"
  File /r /x .svn "..\languages"
  File /r /x .svn "..\..\release\definitions"
  File /r /x .svn /x *.pyc "..\..\release\myownscripts"
  File /r /x .svn /x *.pyc "..\..\release\scripts"
  File /r /x .svn /x *.pyc "..\..\release\web"
 ; File /r /x .svn "..\..\release\sqldrivers"
;  File /r /x .svn "..\..\release\imageformats"
  File "$%QTDIR%\bin\QtCore4.dll"
  File "$%QTDIR%\bin\QtGui4.dll"
  File "$%QTDIR%\bin\QtNetwork4.dll"
  File "$%QTDIR%\bin\QtXml4.dll"
  File "$%QTDIR%\bin\QtSql4.dll"
  File "$%QTDIR%\bin\QtTest4.dll"
  File "$%QTDIR%\bin\QtSvg4.dll"
  File "$%QTDIR%\bin\QtOpenGL4.dll"
!ifdef MSVC8BUILD
  File "..\..\release\msvcp80.dll"
  File "..\..\release\msvcr80.dll"
!endif
!ifdef MINGWBUILD
  File "$%QTDIR%\bin\mingwm10.dll"
!endif
!ifndef PYTHONLESSMODE
  File "$%SystemRoot%\System32\Python24.dll"
  SetOutPath "$INSTDIR\python-dll\"
  File "c:\Python24\DLLs\*.pyd"
  SetOutPath "$INSTDIR\python-lib\"
  File /r "c:\Python24\lib\*.py"
!endif

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Wolfpack.lnk" "$INSTDIR\wolfpack.exe"
  CreateShortCut "$DESKTOP\Wolfpack.lnk" "$INSTDIR\wolfpack.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\wolfpack.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\wolfpack.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\wolfpack.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$DESKTOP\Wolfpack.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Wolfpack.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd