import wolfpack
import housing.house
from signpost import gumpcallback, gump0, gump1, gump2, gump3, gump4, switchgump

def escapeHtml(text):
	text = text.replace('<', '&lt')
	text = text.replace('>', '&gt')
	return text

#
# Show a special tooltip for house signs
#
def onShowTooltip(player, sign, tooltip):
	tooltip.reset()
	tooltip.add(1061638, "") # A house sign
	
	if not sign.multi:
		return
	
	name = 'nothing'
	if len(sign.name) != 0:
		name = escapeHtml(sign.name)
	tooltip.add(1061639, name)
		
	owner = sign.multi.owner
	if not owner:
		tooltip.add(1061640, "nobody")
	else:
		tooltip.add(1061640, owner.orgname)
		
	public = housing.house.isPublic(sign.multi)
	if public:
		tooltip.add(1061641, "")
	else:
		tooltip.add(1061642, "")


def onUse( char, item ):
	# Adding the UID of the Multi here
	if not item.hastag( 'house' ):
		# I found a house here?
		multi = wolfpack.findmulti(item.pos)

		if not multi:
			return True
		
		item.settag( 'house', multi.serial )

	gump0( char, gumpcallback, item )
	return True
