
from wolfpack.consts import RESISTANCE_PHYSICAL, RESISTANCE_ENERGY, \
	RESISTANCE_COLD, RESISTANCE_POISON, RESISTANCE_FIRE, \
	LOWERREQS, LUCK, MATERIALPREFIX

ARMOR_RESNAME_BONI = {
	# Metals
	'iron': {
		RESISTANCE_PHYSICAL: 0,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 0,
	},
	'dullcopper': {
		RESISTANCE_PHYSICAL: 6,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 0,
		LOWERREQS: 20,
		MATERIALPREFIX: 'Dull Copper',
	},
	'shadowiron': {
		RESISTANCE_PHYSICAL: 2,
		RESISTANCE_FIRE: 1,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 5,
		MATERIALPREFIX: 'Shadow Iron',
	},
	'copper': {
		RESISTANCE_PHYSICAL: 1,
		RESISTANCE_FIRE: 1,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 5,
		RESISTANCE_ENERGY: 2,
		MATERIALPREFIX: 'Copper',
	},
	'bronze': {
		RESISTANCE_PHYSICAL: 3,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 5,
		RESISTANCE_POISON: 1,
		RESISTANCE_ENERGY: 1,
		MATERIALPREFIX: 'Bronze',
	},
	'gold': {
		RESISTANCE_PHYSICAL: 1,
		RESISTANCE_FIRE: 1,
		RESISTANCE_COLD: 2,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 2,
		LUCK: 40,
		LOWERREQS: 30,
		MATERIALPREFIX: 'Gold',
	},
	'agapite': {
		RESISTANCE_PHYSICAL: 2,
		RESISTANCE_FIRE: 3,
		RESISTANCE_COLD: 2,
		RESISTANCE_POISON: 2,
		RESISTANCE_ENERGY: 2,
		MATERIALPREFIX: 'Agapite',
	},
	'verite': {
		RESISTANCE_PHYSICAL: 3,
		RESISTANCE_FIRE: 3,
		RESISTANCE_COLD: 3,
		RESISTANCE_POISON: 3,
		RESISTANCE_ENERGY: 1,
		MATERIALPREFIX: 'Verite',
	},
	'valorite': {
		RESISTANCE_PHYSICAL: 4,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 3,
		RESISTANCE_POISON: 3,
		RESISTANCE_ENERGY: 3,
		MATERIALPREFIX: 'Valorite',
	},
	# Leathers
	'leather': {
		RESISTANCE_PHYSICAL: 0,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 0,
	},
	'spined_leather': {
		RESISTANCE_PHYSICAL: 5,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 0,
		LUCK: 40,
		MATERIALPREFIX: 'Spined',
	},
	'horned_leather': {
		RESISTANCE_PHYSICAL: 2,
		RESISTANCE_FIRE: 3,
		RESISTANCE_COLD: 2,
		RESISTANCE_POISON: 2,
		RESISTANCE_ENERGY: 2,
		MATERIALPREFIX: 'Horned',
	},
	'barbed_leather': {
		RESISTANCE_PHYSICAL: 2,
		RESISTANCE_FIRE: 1,
		RESISTANCE_COLD: 2,
		RESISTANCE_POISON: 3,
		RESISTANCE_ENERGY: 4,
		MATERIALPREFIX: 'Barbed',
	},
	# Dragon Scales ( resname2 )
	'red_scales': {
		RESISTANCE_PHYSICAL: 0,
		RESISTANCE_FIRE: 10,
		RESISTANCE_COLD: -3,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 0,
		MATERIALPREFIX: 'Red Scale',
	},
	'yellow_scales': {
		RESISTANCE_PHYSICAL: -3,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 0,
		LUCK: 20,
		MATERIALPREFIX: 'Yellow Scale',
	},
	'black_scales': {
		RESISTANCE_PHYSICAL: 10,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: -3,
		MATERIALPREFIX: 'Black Scale',
	},
	'green_scales': {
		RESISTANCE_PHYSICAL: 0,
		RESISTANCE_FIRE: -3,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: 10,
		RESISTANCE_ENERGY: 0,
		MATERIALPREFIX: 'Green Scale',
	},
	'white_scales': {
		RESISTANCE_PHYSICAL: -3,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 10,
		RESISTANCE_POISON: 0,
		RESISTANCE_ENERGY: 0,
		MATERIALPREFIX: 'White Scale',
	},
	'blue_scales': {
		RESISTANCE_PHYSICAL: 0,
		RESISTANCE_FIRE: 0,
		RESISTANCE_COLD: 0,
		RESISTANCE_POISON: -3,
		RESISTANCE_ENERGY: 10,
		MATERIALPREFIX: 'Blue Scale',
	}
}
